<?php	

global $std_views,$std_error_log,$timestart,$mydir,$std_usr_data;
include("../../include/init.php");
/** \brief Class std, a simple way of managing a table, with all the CRUD characteristcs found in popular packages.
	 * \todo 001 help in checklist for EACH item.
	 * \todo include form.php ? only when actually USED ??its almost always used...
	 * \todo allow detection, and user setting. standard language stuff.
	 * 
	 *
	 * \todo allow show/hide debug info
	 * \todo on delete r u sure you'll delete: xxx with gender
	 * belongs to the allows posibilities in box:style :: iframe,shadow,round:
	 * \todo put more. styles
		
	 * \todo allow template.headerinfo, so we can see the names of the fields, in the field AND in the template.
	 * 
	 * \todo make a list of error codes, and equivalents.
	 * \todo allow show/hide debug info
	 * \todo on delete r u sure you'll delete: xxx with gender
	\author f3l (auditor400@gmail.com)
	Mydir is a simple but effective way of keepoing session stuff separated from each application.
	it should preffix every SESSION operation.	
	\bug has problems here
       	* */
	class std extends db {
		var $default_style='shadow';		///< default style indicates the kind of borders you want arround some elements @see std::ed()
		var $show_menu=1;			/**< menu is by default ENABLED*/

		///@defgroup table table vars
		///@{
		var $id='id';				///< this is the name of the SQL field that has the key of the table.
		var $name='std';			///< the first varchar field of the table
		var $table='STD_NO_TABLE';		///< the name of the table
		///@}
		var $default_module='none';		///< overriden
		var $default_action='view:edit_all';	///<default action indicates what action must be used when no actin is given (useful in places like usr_model::login(), where no previous parameters are set)
		var $restrictions=array('allow'=>array(),'deny'=>array());///<restrictions allow me to give the uesr permissions to stuff he would normally have not permission to, like the login screen, etc
		var $public_modules=array();		///public modules indicate those modules that can be accessd by everyone (however, these modules MUST have public actions, or trhe Guest will be denied access).
		/** 
		 * allows you to set a module which we send people to when they have a login error, that is
		 * the are unauthorized to enter, AND they have no other permissions (not previously logged in)
		 * should be set in &gt;project_name&lt;_base.php
		 * */
		var $login_module='usr';

		function add_public_module($module_name){
			global $mydir;
			$this->public_modules[$module_name]=$module_name;
			$_SESSION[$mydir]['usr']['_priv_mods'][$module_name]=$module_name;

		}

		/** \defgroup i18n Internationalization (i18n)
		 * *some helper functions
		 * */
		//@{
		/**
		 * fi: field i18n
		 * @param key the name of the field.
		 *
		 * */
		function fi($key){
			global $i18n;
			return($i18n[$this->table]['fields'][$key]);
		}
		/**
		 * fh: field help
		 * @param key the name of the field.
		 *
		 * */
		function fh($key){
			global $i18n;
			return($i18n[$this->table]['fields']["help_".$key]);
		}
		//@}
		/**\brief This function returns a form, that's used in the ml() "advanced options" section.
		 * @param $available_fields a list of field keys,
		 * @param $view name the name of the view
		 * \todo multiple vies get saved.
		 * field select
		 *\todo this goes at RIGHT
		 * */

		function get_presets_form($available_fields,$view_name='default'){
			global $mydir;
			///\todo if nothing is selected, create the selection

			if(!array_key_exists('field_presets',$_SESSION[$mydir]['usr'])){
				$_SESSION[$mydir]['usr']['field_presets']=array();
			}	
			if(!array_key_exists($this->table,$_SESSION[$mydir]['usr']['field_presets'])){
				$_SESSION[$mydir]['usr']['field_presets'][$this->table]=array();
			}
			if(count($_SESSION[$mydir]['usr']['field_presets'][$this->table]['default'])==0 || !array_key_exists('default',$_SESSION[$mydir]['usr']['field_presets'][$this->table])){
				$this->set_presets(array_keys($available_fields),"default");//TODO: allow multiple views.	
			}


			$presets=$this->get_presets($view_name);

			$fs=new form();
			$fs->style='show_fields';
			$fs->collapsible=1;
			$fs->strings=array('_form_title'=>$this->get_i18n_text('fields_view'));
			$fs->add_field(array(
				'check_all'=>1,
				'i18n_text'=>$this->get_i18n_text('fields'),
				'i18n_help'=>$this->get_i18n_text('help_fields'),
				'name'=>'fields',
				'type'=>'checklist',
				'options'=>$available_fields,
				'values'=>$presets));
			#p2($this,'red');	
			$fs->add_submit_button(
				array(
					'label'=>$this->get_i18n_text('fields_btn'),
					'action'=>$_GET["ac"])
				);

			$fc=$fs->contents();
			return(array('c'=>$fc["contents"],'o'=>$fs->get_submit_options()));
		}


		/** logs its calls.*/
		function std(){

			$this->log("I AM:".$this->table." LOADING:".implode(',',$this->public_modules),0);
			$this->db();
		}
		/** \defgroup Log
		 * some aaids to development.
		 * */
		//@{

		/**
		 * 
		 * @param $txt the text to be logged
		 * @param $lvl the error level, useful for separating your logs from other, default logs, and setting severity.
		 * \todo add error level filters on VIEW*/
		function log($txt,$lvl=-1){
			global $std_error_log;			
			$std_error_log.="<br/>$lvl:$txt";
		}
		/** \brief gets the log's text 
		 * @return the log's text 
		 * @see std::log() */
		function get_log(){
			global $std_error_log;			
			return($std_error_log);	
		}
		//@}
		/**
			Returns a when action is a/b
			if we ever change the execution mode, I hope this is one of the few places that will need changing.
		*/
		function get_mod($action){
			
			#echo("ac.".$action);
			if(strpos($action,"/")===FALSE){
				return($action);
			}else{
				$ac=explode("/",$action);
				return($ac[0]);
			}	
		}
		/**
		returns current mod and AC,
		it also helps contruction of already existing mods.
		*/
		function mod_and_ac($mod="@none",$ac='@none'){
			if($mod=='@none' && $ac=='@none'){
				if($_GET["ac"]!=''){
					$ac=$_GET["mod"]."/".$_GET["ac"];
				}else{
					$ac=$_GET["mod"];
				}
			}else{
				if($ac!=''){
					$ac=$mod."/".$ac;
				}else{
					$ac=$mod;
				}				
			
			}	
			return($ac);
		}
		
		/** 
		 * retrieves the Title, using AC & MOD information, from the current user's privilege list 
		 * (session.usr._priv) 
		 * */
		function get_title($final=''){
			global $mydir;
			$ac=$this->mod_and_ac();
			#at this point, ac is a/b or just a
		
			$ac1=$this->get_mod($ac);
			$txt='';
			#p2($_SESSION[$mydir]['usr']['_priv']);
			#echo($ac);
			if(array_key_exists($mydir,$_SESSION) && array_key_exists('usr',$_SESSION[$mydir]) && array_key_exists('_priv',$_SESSION[$mydir]["usr"]) && array_key_exists($ac,$_SESSION[$mydir]['usr']['_priv'])){
				$rec=$_SESSION[$mydir]['usr']['_priv'][$ac];
				#p2($rec);
				$txt=$rec["privilege_name"].' / '.$rec["role_name"];
			}
			
			$final=$txt.' @ '.$final;
			return($final);
		}
		/** \defgroup Privilege
		 * *some functions to handle privileges and role management
		 * */
		//@{

		/**
		 * Gets the role name of the current action loking for it in the Session menu array.
		 * */
		function get_role_name($ac){
			global $mydir;
			if(array_key_exists($ac,$_SESSION[$mydir]["usr"]["_priv"])){
				return($_SESSION[$mydir]["usr"]["_priv"][$ac]["role_name"]);
			}else{
				$this->log("no such role for act:".$ac);
				$this->i_error('no_role','std074');
				return("ERROR:Uknown Role");
			}
		}
		/**
		@param $privilege_structure is a record, of the privileges table
		it contains :
		- action
		- role_name
		- privilege_name

		function call looks like this:
		\code
		$this->add_privilege(array('action'=>$this->default_module));
		\endcode
		this one is optimized for privilege lookup, and title rendering
		 */	
		function add_privilege($privilege_structure){
			global $mydir;
			if(!array_key_exists($mydir,$_SESSION)){
				#first time entry, no login.
				$_SESSION[$mydir]=array();
			}
			if(!array_key_exists('usr',$_SESSION[$mydir])){
				#first time entry, no login.
				$_SESSION[$mydir]["usr"]=array();
			}
			if(!array_key_exists('_priv',$_SESSION[$mydir]['usr'])){
				$_SESSION[$mydir]['usr']['_priv']=array();
			}
			if(!array_key_exists('_priv_mods',$_SESSION[$mydir]['usr'])){
				$_SESSION[$mydir]['_pri_mods']=array();
			}
			#the key is the action, for fast lookup.
			$_SESSION[$mydir]['usr']['_priv'][$privilege_structure["action"]]=$privilege_structure;	
			$mod=$this->get_mod($privilege_structure["action"]);
			$_SESSION[$mydir]['usr']['_priv_mods'][$mod]=$mod;
			$this->log('Added:<b>'.$privilege_structure["action"]."</b> : ".$privilege_structure["privilege_name"]." AS ".$privilege_structure["role_name"],0);

		}
		//@}

		/**
		 * \todo do something when is_guest ==1 (like a guest menu?9
		 * 
		 *
			Override when necesary.
			saves the  menu in Session, so its not always recalculated.
			the menu's logo is at /config.php:$application_logo

		 * */

		function menu(){

			global $i18n_std,$config,$mydir;
			$this->log('menu',0);
			$dx='';
			if(array_key_exists($mydir,$_SESSION) && array_key_exists('usr',$_SESSION[$mydir]) && !array_key_exists("_privileges_menu",$_SESSION[$mydir]['usr'])){
				#i have no idea who this guy is, lets find out!
				$all=$this->q2obj(
				"SELECT 
					role.name as role_name,
					privilege.name as privilege_name,
					privilege.action
				FROM 
					usr,
					usr2role,
					role,
					privilege,
					role2priv
				WHERE 
					usr.id			= '".ssid()."' AND
					usr.id 			= usr2role.usr_id AND
					usr2role.role_id	= role.id AND
					role.id 		= role2priv.role_id AND
					role2priv.privilege_id  = privilege.id
					");
				#this one is optimized for menu rendering
				$_SESSION[$mydir]['usr']['_privileges_menu']=$all;
				
				foreach($all as $k6=>$priv){
					$this->add_privilege($priv);
				}
				//mk
			}else{
				#ok, i know who you are, no need to go to the database, right?
				#this simple query caching, will work untill the user logs out.
				#and will save a LOT of trips to he database!.
				$all=$_SESSION[$mydir]['usr']['_privileges_menu'];

			}
			$dta=array();
			$dta[]=array('role_name'=>'','link'=>$i18n_std["menu"]["logged_in_as"].$_SESSION[$mydir]["usr"]["name"]);
						
			$is_guest=0;
			if(count($all)==0 || !is_array($all)){
				$is_guest=1;
				/** \todo do something about it. (user being Guest) */
				#$this->i_error("unable_to_fetch_privileges",'std100');
				#return(0);
			}else{
				#p2($all);
				foreach($all as $k=>$p){
					$acc=explode("/",$p['action']);
					$dta[]=array(
						'role_name'=>$p['role_name'],
						'link'=>"<a href='?mod=".$acc[0]."&ac=".$acc[1]."'>".$p['privilege_name']."</a>"
					);
				}		
				$dta[]=array('role_name'=>'<!---->','link'=>"<a href='?logout=1'>".$i18n_std['logout']."</a>");
			

				if($this->show_menu==1){
		 			echo("<div class=system_menu align=left>");
					$this->shadow(
						"<div align=center><a href='?'><img border=0 class=app_logo src='".$config["application_logo"]."' /></a></div>".
						$this->li($this->group_by2($dta,'role_name','link'))
						,'iframe');
					echo("</div>");
				}
			}	
		}
		/** 
		 * searches for _id at the end of a a string
		 * */
		function is_id($field){
			return(preg_match('/(_)?id$/i',$field));
		}		
		/** \ingroup Privilege
		 * \brief allows the user to "login"
		 * since we are on the default module, that is, our URL without parameters, 
		 * perhaps we should LET the user do this, right?
		 * \todo i18n
		*/
		function ap_login(){
			$this->add_privilege(array(
				'privilege_name'=>'Login',/* a simple & naive assumption, not always true*/
				'action'=>$this->default_module));
			$this->add_privilege(array(
				'privilege_name'=>'Login',
				'action'=>'usr/login2'));

		}
		/** \brief retrieves the function list, using a given filter
		 * @param $filter the beginning of the function name.
		 *
		 * some reflection
		 * */
		function get_func_list($filter='ac_'){
			return(
				$this->aa(
					array_filter(
						get_class_methods($this),
						create_function('$a','return(preg_match("/^'.$filter.'/",$a));')
					)
				)
			);
		}

		/** \brief This, is where real excecution starts.
			STATIC
			\todo try to find a way not to load modules twice, 
			when so requested, and reuse the already loaded ones.
			
			\todo remove odd characters like pipe, .. etc from mod name.
			\todo 923 check for existance of such function.
		 */
		function load_current_module(){
			
			global $i18n_std,$mydir;
			if(!array_key_exists('mod',$_GET) || $_GET['mod']==""){
				$_GET['mod']=$this->default_module;	/*default_module*/
				$this->ap_login();
			}
			
			$module=$this->load_file($_GET['mod']) ;
			if($module==0){
				std::msg("Unable to continue");
				return(0);
			}
			
			if(!array_key_exists('ac',$_GET) || $_GET['ac']==""){
				#no ac, lets check for submit.

				if(array_key_exists('_submit',$_GET)){
					#look for of the _submit array that match what the user clicked (get.submit)
					$founs=0;
					foreach($_GET["_submit"] as $k2=>$v2){
						if($_GET["submit"]==$v2){
							$action="ac_".$k2;
							#GET is emulated, so everyone thinks that all is good in the world, 
							#and never see or have to deal with this litle hack directly
							$_GET["ac"]=$k2;
							++$found;
							break;		
						}
					}
					if(!$found){
						$this->i_error('submitted_action_not_found','std070');
					}
				}else{
					#if we dont find it, well use the mod's default.
					$action="ac_".$module->default_action;
				}

			}else{
				#action comes from GET.
				$action='ac_'.$_GET['ac'];
			}

			$action2=explode(":",$action);
			if(count($action2)==1){
				$real_action=$action;
				$module->current_view='none';
			}else{
				$real_action=$action2[0];
				$module->current_view=$action2[1];
			}
			
			#GETS delete from ac_delete
			$module->current_action=substr($real_action,strlen('ac_'),strlen($real_action));

			/*923*/
			$module->name=$_GET['mod'];
			if(!in_array($real_action,get_class_methods($module))){
				/*WHAT IS THIS??? todo remove html */
				$this->i_error('no_such_action','std071',array('ac'=>$real_action,'mod'=>$module->name));
			}else{
				#if the user's not authorized, then he can't go trough.
				if(array_key_exists($mydir,$_SESSION) && array_key_exists('usr',$_SESSION[$mydir]) && array_key_exists('_priv_mods',$_SESSION[$mydir]['usr']) && !in_array($module->name,$_SESSION[$mydir]['usr']['_priv_mods'])){
					$this->i_error("no_auth_mod",'std072');	
					$this->log($module->name." not in ".implode(",",$_SESSION[$mydir]['usr']['_priv_mods']));
				}else{
					#ok, the user's got the mod, now let's see if he's got the act...
					$m=$this->mod_and_ac();
					
					$this->log("testing AC:'$action' $m",0);
					if(in_array($action,$module->restrictions["allow"])){
						$allowed=1;
						#since there IS probably no role for this, ill just add it manually.
						$this->ap($m,'form',$i18n_std["roles"]['guest']);
					}else{
						$allowed=0;
					}
					
					if($allowed || $this->is_allowed($m)){
						$module->$real_action();
					}else{
						if(is_array($_SESSION[$mydir]["usr"]["_priv"])){
							$this->i_error('no_auth_ac','std073',array('ac'=>$m));
							$this->log("$m not in:<br/>".implode(",<br/>",array_keys($_SESSION[$mydir]["usr"]["_priv"]))." nor in: ".implode(',',$this->restrictions["allow"]),'ERROR');
						}else{
							//first time system entry, means we should provide a login screen.
							//the problem: WHICH is the login module?
							$mm=$this->load_file($this->login_module);
							$mm->attempted_action=$_GET["ac"];
							$mm->attempted_module=$_GET["mod"];
							$mm->ac_login();
							$this->log("$m not in : empty list");
						}	
					}	
				}
			}	
		}
		
		/** \ingroup Privilege
		 * determines if a user has privileges to do $action, searching in the Session[$mydir][usr][_priv] struct,
		 * for that key. 
		 * @param $m the key of the session array to be looked up for
		 * @returns boolean wether or not the user has that privilege.
		 * */
		function is_allowed($m){
			global $mydir;
			return( array_key_exists($mydir,$_SESSION) 
				&& array_key_exists('usr',$_SESSION[$mydir]) 
				&& array_key_exists('_priv',$_SESSION[$mydir]['usr']) 
				&& array_key_exists($m,$_SESSION[$mydir]["usr"]["_priv"]));
		}

		/**
		 * WARNING:THIS ALLOWS (grants privilege to current user) ANYTHING YOU SET AS ACTION.
		 * $ac: requires no MOD
		 * $fields: a list of KEYS (not actual fields.), or the word "all"
		 * \todo allow multiple ac
		 * */
		function form_from_fields($ac,$fields,$options){

			global $i18n;
			if(!array_key_exists('title',$options)){$options['title']='notitle';}
				
			$title=$options['title'];

			$f=array();

			if($fields=='all'){
				$f=$this->fields;
			}else{
				foreach($fields as $k=>$f1){
					$f[$f1]=$this->fields[$f1];
				}
			}
			if($title=='notitle'){
				$tt=$i18n[$this->name]['table_title'];
			}else{
				$tt=$title;
			}	
			#echo($ac);	
			$this->ed(array(
				'actions'=>array($ac),
				'rawtitle'=>$tt,
				'data'=>'',
				'style'=>'iframe',
				'fields'=>$f,
			));


			#add privilege
			$this->add_privilege(array(
				'action'=>$this->mod_and_ac($_GET['mod'],$ac),
				'privilege_name'=>$i18n[$this->table]['table_plural'],
				'role_name'=>$i18n_std["roles"]["guest"],/* Guest, until otherwise proven.*/
			));
		}
		/** \brief Prints HTML prelude, css,js, etc
		 * if you override this, you can set your own headers.
		 * @param $title the title of the page 
		 * @returns nothing
		 * */
		function head($title="Untitled Section"){
			
			$title=$this->get_title($title);
			echo("<html><head>
				<META HTTP-EQUIV=\"Content-Type\" CONTENT=\"text/html; charset=ISO-8859-1\">
				<title>".$title."</title><script src='../../include/js.js'></script><link rel=stylesheet tyle='text/css' href='../../shared_media/style.css' /></head><body>\n<!--start-->\n");
		}
		
		/**
		 * $field:	a field structure
		 *
		 * retermines if a field is from another table, looking for _id at the end or at the [foreign] key.
		 * it also checks that the field isnt "my_id"
		 * */
		function field_is_foreign($field){
			$c=0;
			if($field['name'] == $this->id ){return(0);}

			if($this->is_id($field['name'])){
				$this->log("i think ".$field['name']." is foreign since it has a is_id()",8);				
				return(1);}
			if(array_key_exists('foreign',$field)){
				$this->log("i think ".$field['name']." is foreign since it has a FOREIGN FIELD",8);
				return(1);}
			return(0);
		}
		/** \defgroup presets
		 * this functions allow the user to have "custom" views, based on standard views
		 * \todo views have fields that show ONLY on list, not by default.
		 *
		 * */
		//@{	
		/**
		 * from SESSION, or user data, whatever comes first.
		 * \todo 901 validate $_GET
		 * \todo 902 validate fields in range (in available)
		 * \todo 903 save that to .rc.php file
		 * */
		function get_presets($udf_view='default'){
			global $mydir;
			if(isset($_GET["fields"])){
				#$available_fields=$_GET["fields"];
				$_SESSION[$mydir]['usr']['field_presets'][$this->table][$udf_view]=$_GET["fields"];
			}

			return($_SESSION[$mydir]['usr']['field_presets'][$this->table][$udf_view]);
		}
		/**
		 * from SESSION
		 * */
		function set_presets($ar,$udf_view='default'){
			global $mydir;
			$_SESSION[$mydir]['usr']['field_presets'][$this->table][$udf_view]=$ar;
		}
		//@}


		/**\brief Print Footers
		 * this prints the Footers, and displays debugging informatin, about the database, sql queries, and the LOG.
		 * it also prints how long it took the script to complete, for profiling.
		 * @see log
		 * @see trace
		 * @see $timestart
		 * WARNING: this function is called not from the module, but from the base, where no $this->table or any of that stuff exists.
		 *
		 * */
		function foot(){
			
			global $std_error_log,$timestart,$mydir,$std_usr_data;

			echo("\n\n<!--end-->\n");		
			if(DEBUG){
				#display database information.
				$this->trace();
				$this->shadow_start();
				echo("<h1>PHP ERROR LOG</h1>");
				
				echo($this->get_log());
				echo("<br/>FIELD PRESETS:<br>");
				p2($_SESSION[$mydir]['usr']['field_presets']);
				echo("<br/>USER DATA:<br>");
				p2($std_usr_data);
				p2($_GET,'blue');
				$timeend = microtime();
				$diff = number_format(((substr($timeend,0,9)) + (substr($timeend,-10)) - (substr($timestart,0,9)) - (substr($timestart,-10))),4);
				echo "<br/><br/>Script generation took $diff s ";
				$this->shadow_end();
				
			}
			echo("</body></html>");
		}
		
		function load($base_module){
			$file=$base_module.'_base.php';
			if(!file_exists($file)){
				std::error("no such file");
			}else{
				include($file);
			}
		}
		function id2mod($k1){
			$tbl=explode('_id',$k1);
			return($tbl[0]);
		}
			
		function delete_record($id){
			global $i18n_std;
			$id=$this->remove_strange_chars($id);
			$this->sql('DELETE FROM '.$this->table." WHERE ".$this->id." ='$id' ");
			if($this->affected()==1){
				$this->msg($i18n_std['list']['form_delete_ok'].$this->b2l_link());
			}else{
				$this->error($i18n_std['error']['delete'].$this->b2l_link(),'006');
			}
		}

		/** 
		 * \todo countless validation schemes., telephone, ac, etc 
		 * \todo validate data within range, make sense feb31
		 * */
		function validate($data,$field){
			
			$data=$this->remove_strange_chars($data);
			if($field['type']=='password'){
				$data=md5($data);
			}elseif($field['type']=='date'){
				/** \todo validate data within range, make sense feb31*/
				$y=$this->remove_strange_chars($_GET[$field['name'].'_year']);
				$m=$this->remove_strange_chars($_GET[$field['name'].'_month']);
				$d=$this->remove_strange_chars($_GET[$field['name'].'_date']);

				$data="$y-$m-$d 00:00:00";
			}else{
				$data=$data;	
			}
			return($data);
		}

		/**
		 * check if a field has foreign data inside its name, like tablename_id or stuff like that
		 * */
		function field_is_deportable($field){
			return($field['name'] != $this->id && ($this->is_id($field['name']) ));
		}

		/**
		 * adds what it takes to make table_id a array(type=whatever,foreign=table.field)
		 * so we can greatly simplify the eecution process.
		 * it returns the field back, fixed.
		 * */

		function field_deport($field){
			if($this->field_is_deportable($field)){
				$modname=$this->id2mod($field["name"]);
				$fm=$this->load_file($modname);
				$field['foreign']=$fm->table.".".$fm->name;
			}	
			return($field);
		}

		/**
		 * this searches for duplicate tables, so we can check if we actually need alias functionality, 
		 * or can use old fashoned SQL, with no alias (which is kinda simpler to work with, and some of 
		 * our apps depend on already anyway)
		 * */
		function need_alias($which_fields){
			$use_alias=0;
			
			#p2($which_fields);
			$this->log("NEED ALIAS: fields:".count($which_fields),0);
			$used_mods=array();
			if(is_array($which_fields)){
				foreach($which_fields as $k=>$field){
					if($this->field_is_deportable($field) && $this->field_is_foreign($field)){
						$field=$this->field_deport($field);
					}
					if($this->field_is_foreign($field)){
						#stuff is already in spected format
						#fields are not DEPORTED

						$this->log("FIELD $k IS FOREIGN; SINCE:".$field['foreign']);
						$f3=explode('.',$field['foreign']);
						$modname=$f3[0];
						if(in_array($modname,$used_mods)){
							$this->log("im using alias because of repeated table in field:$k,".in_array($modname,$used_mods)."mn:".$modname.$used_mods);
							$use_alias=1;
							break;
						}
						$this->log($modname." not in ".implode(",",$used_mods),2);
						$used_mods[$modname]=$modname;
					}else{
					
						$this->log($k." is not foreign",2);
					}
					
					
				}
			}else{
				$this->log("fields are somwhow WRONG:.".$which_fields."..",'WARNING');
			}
			$this->log("@view:use alias:$use_alias",0);
			return($use_alias);
		}		

		/**
			returns a SQL statement of all the fields, joined.
			it allows just a few fields, and not all of them, an array of keys
			it returns an array with the following keys:
			
				sql:		the join statement
				sfields:	an array with the fully qualified names of the fields.
				csql: 		a sql statement of count() (useful for your Pagination scheme,
						c sql retusnr the count() of your designated ID field ($this->id) as the "c" field.
						that's right, it is YOU who implentents it.)
				restrict:	a SQl where clause, so you can trim down your results, to only the relevant set.
			
			\todo allow restrictions on foreign fields, restrict. (a lot of editown goes here, right?)
       			* */
		function foreign_select($options){

			global $i18n,$i18n_std;
			$sort_field=$options['sort_field'];
			$sort_direction=$options['sort_direction'];
			$which_fields=$options['fields'];
			$restrict=$options['restrict'];
			if($restrict==''){$restrict='1=1';}

			$fields=array();
			$sfields=array();	//al fields in a.b notation
			$sql_fields=array();	//all fields in a_b notation

			$tables=array($this->table);
			#$table_aliases=array($this->table=>$this->table);
			$join=array('1=1');
			$final=array();
			#echo("ST:");p2($which_fields,'red');
			$na=$this->need_alias($which_fields);
			$ialias=0;
			foreach($which_fields as $k=>$field){
				#$is_foreign=array_key_exists('foreign',$field);
				if($this->field_is_foreign($field)){	/*field is foreign, join tables*/
					
					if($field["display_id"]==1){
						#Standard behaviour states that we just want the Foreign data, 
						#but not the actual IDs, here, im telling the program that i 
						#also want the IDs, so i can do operations with them.
	
						$sfields[$this->table.".".$k]=$this->table.".".$k;
						$fields[""]=$this->table.".".$k." AS ".$this->table."_".$k;
					
					}
					$field=$this->field_deport($field);
					
					$f3=explode('.',$field['foreign']);
					$modname=$f3[0];
					$foreign_field=$f3[1];
					$fm=$this->load_file($modname);
					
					if($na==1){
						$tblalias=$fm->table.'_alias_'.$ialias;	#generates aliases like:whatever_alias_0 ,etc	
						$tables[]=$fm->table.' AS '.$tblalias;
					}else{
						$tables[]=$fm->table;
						$tblalias=$fm->table;
					}
					#$table_aliases[$fm->table]=$tblalias;
					$join[]=$tblalias.'.'.$fm->id." = ".$this->table.".".$k;
					
					$fields[$k]=$tblalias.".".$foreign_field." AS ".$tblalias."_".$foreign_field;
					$sfields[$fm->table.".".$foreign_field]=$fm->table.".".$foreign_field;
					$sql_fields[$k]=$tblalias."_".$foreign_field;
					$ialias++;		
				}else{						/*field is NOT foreign, add to list*/
					$sql_fields[$k]=$this->table."_".$k;
					$sfields[$this->table.".".$k]=$this->table.".".$k;
					$fields[$k]=$this->table.".".$k." AS ".$this->table."_".$k;
				}
				
			}
			$fw=	"\n FROM \n\t".implode(",\n\t",$tables).
				"\n WHERE \n\t( ".implode(" AND\n\t",$join)." ) AND ($restrict)";

			return(array(
				#'table_aliases'=>$table_aliases,
				'sql_fields'=>$sql_fields,
				'sfields'=>$sfields,
				'sql'=>"SELECT \n\t".implode(",\n\t",$fields).$fw."\n ORDER BY ".$sort_field .' '.$sort_direction,
				'csql'=>"SELECT \n\tcount(".$this->name.".".$this->id.") as c ".$fw
			));

		}

		function get_headers(){
			global $i18n;
			$f=array();
			foreach($this->fields as $k=>$field){
				$f[$k]=$i18n[$this->name]['fields'][$k];
			}
			return($f);
		}

		/**
			returns a "back to list", when Apropiate.
			and adds the  Privilege, since it must be explicit.
		*/
		function b2l_link(){

			global $i18n,$i18n_std,$mydir;		
			if(is_array($_SESSION[$mydir]["usr"]["_search"]) && array_key_exists($this->table,$_SESSION[$mydir]["usr"]["_search"])){
				$this->ap('b2l');
				return("<br/><br/>".$this->make_link(array('mod'=>$this->table,'ac'=>'b2l'),$i18n_std["list"]["form_b2l"],'b2l_link'));
			}else{
				return("<br/><br/>");
			}	
		}

		/**
			\todo title, tooltip, etc.
			\todo use this EVERYWHERE.
		 */
		function make_link($options,$text,$class='link'){
			#p2($options);
			$txt="<a class='$class' href='?";
			$l=array();
			foreach($options as $k=>$v){
				$l[]="$k=$v";
			}
			#echo("return:".$txt.implode("&",$l)."'>".$text."</a>");
			return($txt.implode("&",$l)."'>".$text."</a>");
		}
	
		/**
		 *	display a single record.
		 *	 recieve STYLE
		 * */
		function ed($options){
			
			global $i18n_std,$i18n;

			if(!array_key_exists($options['title'],$i18n[$this->table])){
				if(!array_key_exists('rawtitle',$options)){
					$title="error: title not found.".$options['title'];
				}else{
					$title=$options['rawtitle'];
				}	
			}else{
				$title=$i18n[$this->table][$options['title']];
			}
			if(!array_key_exists('style',$options)){
				$options['style']=$this->default_style;
			}		
			$dta=$options['data'];
			#p2($options,'red');
			#$ac,$title,$ok,$dta
			#just a nick name
			$form_fields=$options["fields"];

			if($dta==''){
				#no data was given. use defaults.
				$dta[0]=array();
				foreach($form_fields as $kk1=>$vv1){
					$dta[0][$kk1]=$vv1['value'];
				}
			}
			
			foreach($dta as $k=>$row){
				foreach($row as $k1=>$field){
					/** \todo if not in list, warn user about changed database, send email admin*/
					if(!array_key_exists($k1,$form_fields)){
						$this->error($i18n_std['error']['application_corrupt'].$k1,'std001');
					}
					$is_foreign=array_key_exists('foreign',$form_fields[$k1]);
					if($this->field_is_foreign($form_fields[$k1])){
						/**
						 * \todo add foreign stuff here
						 * its and ID and its not ME, then its foreign.
						 */
						if($form_fields[$k1]['type'] !='hidden'){

							if($form_fields[$k1]['type']=='label'){
								#since it's a label, i want to show it's current value, 
								#and preserve the hidden input, with the actual ID's value
							
								#$form_fields[$k1]['type']='list';
							}else{
								$form_fields[$k1]['type']='list';
							}
							$foreign_restrict=' 1=1 ';	
							if($is_foreign){
								#restrict the records obtained by a sql where expression.
								if(array_key_exists('restrict',$form_fields[$k1])){
									$foreign_restrict=$form_fields[$k1]["restrict"];	
								}
								
								#syntax is tablename.fieldname
								#WARNING THIS LOGIC IS REPLICATED @ foreign_select, & @ ml()
								$f3=explode('.',$form_fields[$k1]["foreign"]);
								$foreign_mod=$f3[0];
								$foreign_field=$f3[1];
							}else{
								$foreign_mod=$this->id2mod($k1);
							}
							$fm=$this->load_file($foreign_mod);
							if(!$is_foreign){
								$foreign_field=$fm->name;
							}
							if($form_fields[$k1]['type']=='label'){
								#FETCH a single Record, the one with the current's "value"
								$v9=$this->q2op("SELECT * FROM ".$foreign_mod." WHERE ".$foreign_restrict." AND ".$fm->id." = '".$form_fields[$k1]["value"]."'",$fm->id,$foreign_field);
								$form_fields[$k1]['display_value']=$v9[$form_fields[$k1]["value"]];
							}else{
								$form_fields[$k1]['options']=$this->q2op("SELECT * FROM ".$foreign_mod." WHERE ".$foreign_restrict,$fm->id,$foreign_field);
							}
						}
					}
					$form_fields[$k1]['value']=$field;
					$form_fields[$k1]['exists_in_list']=1;
				}
			}
			foreach($form_fields as $k=>$field){
				if($field["exists_in_list"] !="1"){
					$this->log(''.$k.' not in list','ERROR');
					$this->error($i18n_std['error']['application_corrupt2'].$k,'std002');		
				}
			}
			
			$f =new form($form_fields);
			#$f->add_field(array('type'=>'hidden','name'=>'ac','value'=>$ac));
			$f->add_field(array('type'=>'hidden','name'=>'mod','value'=>$this->table));
			$f->strings=$i18n[$this->table]['fields'];
			$f->strings["_form_title"]=$title;
			
			
			#$f->strings["ok"]=$ok;
			foreach($options['actions'] as $k1=>$v1){
				$f->add_submit_button(array('label'=>$this->get_i18n_text($v1,'form_'),'action'=>$v1));
			}
			$this->shadow($f->out(),$options['style'],'center','60%');

		}#end ed

		/**
		 * this looks for i18n keys inside the i18n_std and the i18n[table]arrays, for keys matchng prefix.key 
		 * it exists mainly for buttons.
		 * */
		function get_i18n_text($key,$prefix='form_'){
			global $i18n,$i18n_std;
			if(array_key_exists($prefix.$key,$i18n[$this->table])){
				return($i18n[$this->table][$prefix.$key]);
			}elseif(array_key_exists($prefix.$key,$i18n_std['list'])){
				return($i18n_std['list'][$prefix.$key]);
			}else{
				$this->log("Uknown i18n key:".$prefix.$key." @ ".implode(',',$i18n).' nor in i18n_std','WARNING');
				return("");
			}
		}

		/** this is a dummy filter, its purpose is to do NOTHING to an array that's passed to it,
		 *  and then return the array, this is used as a part of the system that allows you to 
		 *  filter anything that goes trough std::ml() (all the views(), that is, *your* custom defined views.)
		 *  */
		function filter_none($number,$record){
			return($record);
		}
		/**
		 * i18n (internationalized) message
		 * */
		function i_msg($message,$message_stuff=array()){
			#saves all the boilerplate stuff of i18n
			#kinda repeated from i_error...
			global $i18n_std;
			echo($this->get_i_msg($message,$message_stuff));
		}

		function get_i_msg($message,$message_stuff=array()){
			#saves all the boilerplate stuff of i18n
			#kinda repeated from i_error...
			global $i18n_std;
			return($this->get_msg($this->fmt($i18n_std["msg"][$message],$message_stuff)));
		}
		
		function i_error($error_string,$error_code,$error_stuff=array()){
			#saves all the boilerplate stuff of i18n
			#and prints an error message.
			#
			global $i18n_std;
			$this->error($this->fmt($i18n_std["error"][$error_string],$error_stuff,''),$error_code);

		}
		
		/* 
		 * @defgroup View_Handlers 
		 * These functions act like handlers that can be used in views, and
		 * in the creation of new view types, so you can have a view type "grid", "calendar", etc.
		 * 
		 * */
		
		//@{
		/**
		 * View Handler Table: allows you to see a number of items, and controll them.
		 * it also saves the search in session, so we can use b2l
		 * */
		function vh_table($view){
			global $mydir;
			$this->ml($view);
			#save search in session.
			$_SESSION[$mydir]["usr"]["_search"][$this->table]=$_GET;
			$this->log("Saved search");

		}

		/* grid view
		 * \todo finish 
		 * */
		function vh_grid($view){
			#simple, uh
			global $mydir;
			echo("Welcome to the jungle");
			$this->ml($view);
			#save search in session.
			$_SESSION[$mydir]["usr"]["_search"][$this->table]=$_GET;
			$this->log("Saved search");

		}

		/**
		 *	\todo save register,  in Session, then check if the information is the same, before insert, if different, warn about changes.
			\todo on view myself, there must be a , that send you to edit2own, so you cant tamper that either. listown / editmyself, that checks that you dont edit other's people stuff
			
			recieves parameters:
			actions	an array of actions (actions must be coded in )
			title		the title of the form (key of i18n)
			fields:	an array of fields.
					each field is a Field Structure
			\todo allow foreign with ranges.
		 * */
		function vh_record($view){
			global $i18n_std,$i18n;

			$id=$this->remove_strange_chars($_GET['id']);
			$data=$this->q2obj("SELECT * FROM ".$this->table." WHERE ".$this->id." ='$id' ");
			if(count($data)==0){
				if($view["if_not_exists"]=='create'){
					#We are on an INSERT view
					$data=array();
					
					foreach($view["fields"] as $k=>$field){
						if($this->id==$field['name']){
						
							$view['fields'][$k]["type"]='hidden';#DO NOT DISPLAY ID, its an insert, pal!
						}
						$data[0][$field['name']]=$field['value'];#could be nothing...
							
					}
					
				}else{
					#this is an UPDATE, failed because no such recod exists on DB
					$this->i_error('no_such_record','std060');
					return(0);
				}	
			}	
			#p2($view);
			#this is an update
			$view["data"]=$data;
			$this->ed($view);

		}
		//@}



			/* MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM AC START   */
		
		/** 
		 * this deletes the items that were marked for deletition, in the list.
		 * calls menu()
		 * \todo click on "id" to "check all", 
		 * \todo confirm page
		 * */
		function ac_delete_selected(){
			$this->menu();
			$errors='';
			foreach($_GET['item'] as $k=>$id){
				$this->sql('DELETE FROM '.$this->table." WHERE ".$this->id." ='".$this->remove_strange_chars($id)."'");
				if($this->affected()==0){
					$errors.='<br/>error:'.$id;
				}else{
					$errors.='<br/>ok:'.$id;
				}
			}
			$l=$this->b2l_link();
			$this->msg($errors."<br>".$l);
		}

		/** \brief shows a view
		 * a view is a list of fields, handlers and links,
		 * examples of views, ca vbe: the Edit form, the Add form, and the table, where many elements are shown.
		 *
		calls menu().
		This system allows user defined handlers, 
		so you can have a view type XXX and define a handler for it.!
		that way you can extend the functionality, in a STILL generic way, cool!
		
		also, this will ALLOW() the user to all of its actions, so be careful.
		 */

		function ac_view(){
			global $std_views,$i18n_std,$i18n;

			$this->menu();	

				#no longer a problem, we have shared views.
				#$this->i_error('no_views','std020');
				#echo($This->table);

			if(array_key_exists($this->table,$std_views) && array_key_exists($this->current_view,$std_views[$this->table])){
				$view1=$std_views[$this->table][$this->current_view];
			}else{
				#there is no view, lets see if its a shared one.
				if(!array_key_exists($this->current_view,$std_views["std"])){
					$this->i_error('no_such_view','std075',array('view'=>$this->current_view));
					return(0);
				}else{
					#its a Shared View(TM) !
					$view1=$std_views['std'][$this->current_view];
				
				}	
			
			}			
				
			#p2($std_views);
			#
			#
			$vh="vh_".$view1["type"];
			if(!in_array($vh,get_class_methods($this))){
				$this->log("no view handler:".$vh);
				$this->i_error('no_view_handler','std050');
			}else{
				#add privs, so everything HERE is automagically possible, and OK.
				#please be careful.
				#p2($view1);
				$p=array(); #all my privileges.
				foreach(array('side_'=>'side_actions','down_'=>'down_actions','form_'=>'actions') as $k2=>$ac_list){
					if(array_key_exists($ac_list,$view1)){
						foreach($view1[$ac_list] as $k3=>$priv1){
							$p[]=array(
								'action'=>$this->mod_and_ac($_GET["mod"],$priv1),
								'privilege_name'=>$i18n[$this->table]['table_plural']." : ".$i18n_std['list'][$k2.$priv1],
								#whomever i am NOW, must be what i run these babys on
								/** \todo handle GUEST case.*/
								'role_name'=>$this->get_role_name($this->mod_and_ac()),
							);
						}#end for
					}	
				} 
				foreach($p as $k1=>$rec){
					$this->add_privilege($rec);
				}
				
				#run view
				if($view1["fields"]=='all'){
					$view1["fields"]=$this->fields;
				}
				$this->$vh($view1);
			}
		}#end ac_view

		/**
			#restores the user to a specific point in a search result set,
			#pagination, sort order, ac, etc, its all restored.
		 * */
		function ac_b2l(){
			global $mydir;
			if(!is_array($_SESSION[$mydir]["usr"]["_search"]) || !array_key_exists($this->table,$_SESSION[$mydir]["usr"]["_search"])){
				$this->error("there is no list",'std010');
				/** \todo look for allows lists, show that one.*/
				p2($_SESSION[$mydir]["usr"]["_search"]);
			}else{
				#retrieve old data from SESSION
				$_GET=$_SESSION[$mydir]["usr"]["_search"][$this->table];
				
				#go back to were i was, wherever the uck that is.
				
				$this->load_current_module();
			}
		}


		/**
		 * #Exports table to Excel	
		 * \todo :remove old exports
		 * */
		function ac_xls(){
			global $i18n_std,$i18n;
			$this->menu();
			$fs=$this->foreign_select(array(
				'fields'=>$this->fields,
				'sort_field'=>$this->table.'.'.$this->id,
				'sort_direction'=>'ASC'
			));

			$a=$this->q2obj($fs['sql']);
			$fn='../../excel_files/'.$i18n[$this->table]['table_plural'].date('Y_m_d__H_i_s').md5('youcantgetme__'.date('Y_m_d__H_i_s')).'.xls';
			$date1="<b>".$i18n_std['generated_on'].date('Y-m-d H:i:s')."</b>";
			$this->file_write($fn,
				$this->table(
					$a,
					$this->get_headers(),
					array(
						'border'=>1,
						'title'=>"<h1>".$i18n[$this->table]['table_plural']."</h1>".$date1,
						'footer'=>$date1
					)),1,1);

			echo("<a href='$fn'>".$i18n_std['download'].$i18n[$this->table]['table_plural']."</a>");
		}
		function ac_edit(){
			#Calls Menu()
			global $i18n,$i18n_std;
			$this->menu();
			echo("deprecated.");

		}

		/**
		 * Calls Menu()
		 * \todo add 'back2list'
		 * */
		function ac_edit2(){//edit
			global $i18n_std;
			$this->menu();
			$sql=array();
			foreach($this->fields as $k=>$field){
				/** \todo check if not in array warn, program malformation.*/
				
				$_GET[$field['name']]=$this->validate($_GET[$field['name']],$field);
				$sql[]=" ".$field['name']." = '".$_GET[$field['name']]."' ";

			}
			
			$this->sql('UPDATE '.$this->table." SET \n\t".implode(",\n\t",$sql)." \nWHERE\n ".$this->id." ='".$_GET[$this->id]."'");
			#back to list link.
			$b=$this->b2l_link();
			if($this->affected()==1){
				$this->msg($i18n_std['list']['form_update_ok'].$b);
			}else{
				$this->msg($i18n_std['list']['form_no_update'].$b);
			}
		}

		/**
		 * grants the user, privileges over a given action, grouping it using the current's action privileges.
		 * $role, is a parameter that indicates wether you should use a role, from the list, or a nice (hopefully i18n compatible) word like "guest"
		 * */
		function ap($ac,$prefix='form',$role='@search',$table='@me'){
			
			if($table=='@me'){$table=$this->table;}else{
				$this->load_file($table);
			}
			#echo("CU:".$this->current_action);
			if($role=='@search'){
				$role=$this->get_role_name($this->mod_and_ac($table,$this->current_action));
			}

			$this->add_privilege(array(
				'action'=>		$this->mod_and_ac($table,$ac),
				'role_name'=>		$role,
				'privilege_name'=>	$i18n[$table]['table_plural']." : ". $i18n_std['list'][$prefix . $ac],
			));
		
		}

		function ac_delete(){
			#Calls Menu()
			global $i18n,$i18n_std;
			$this->menu();
			$f=new form();
			$f->add_field(array('type'=>'hidden','name'=>'id','value'=>$this->remove_strange_chars($_GET['id'])));
			$f->confirm($this->name,'delete2',$i18n_std['list']['form_confirm']);
			$this->ap('delete2');
		}

		function ac_delete2(){
			#Calls Menu()
			global $i18n,$i18n_std;
			$this->menu();
			if($_GET['answer']=='yes'){
				$this->delete_record($_GET['id']);
			}else{
				$this->msg($i18n_std['list']['form_cancelled']);	
			}	
		}
		/***
		 * \deprecated 
		 * use view:edti_all instead.
		 * */
		function ac_list(){
			#Calls Menu()
			
			global $i18n,$i18n_std;
			$this->menu();
			echo("Deprecated:list");
			/*
			$this->ml(
				array(
					'fields'=>$this->fields,
					'title'=>"table_plural",
					'down_actions'=>array('xls','new'),
					'side_actions'=>array('edit','delete'),
					)
				);
			 */
			
		}

		/**
		 * \todo data validations according to Type
		 * */
		function ac_new(){
			global $i18n,$i18n_std;
			$this->menu();
			echo("DEPRECATED");

			#$this->ac_create();
		}

		/**
		 * returns 1 on success and 0 on faluire
		 * */
		function ac_new2(){
			global $i18n,$i18n_std;			
			
			$this->menu();
			$f=array();
			$allok=1;
			$failed_field='';
			foreach($this->fields as $k=>$field){
				if($field['type']=='password'){	/** \todo more validation schemes, a validation function, validate dates within ranges, validate stuff within ranges, validate within lists, etc, remove errors like feb 31, etc.*/
					$_GET[$k]=md5($_GET[$field['name']]);
				}
				$_GET[$field['name']]=$this->validate($_GET[$field['name']],$field);
				$f[]="'".$_GET[$field['name']]."'";
				if($field["type"]=='date'){
				$this->log("valor:".$_GET[$field['name']],9);
				}
				/*This field cannot be repeated in the database, sorry. */
				if(array_key_exists('unique',$field) && $field['unique']==1){
					$d=$this->q2obj("SELECT count(*) as c FROM ".$this->table." WHERE ".$field['name']." = '".$_GET[$field['name']]."'");
					if($d[0]['c']!=0){
						$failed_field_name=$i18n[$this->table]['fields'][$field['name']];
						$failed_field_value=$_GET[$field['name']];/**\todo  i18n*/
						$allok=0;
						break;	
					}
				}
			}
			if($allok==1){
				$this->sql('INSERT INTO '.$this->table.' VALUES('.implode(',',$f).')');
				$b=$this->b2l_link();
				if($this->affected()==1){
					$this->i_msg('form_inserted_ok',array('b2l'=>$b));
					return(1);
				}else{
					$this->i_msg('insert_error',array('b2l'=>$b));
					return(0);
				}
			}else{
				$this->i_msg('not_unique_field',
					array(
						'table'=>$i18n[$this->table]['table_plural'],
						'field_value'=>$failed_field_value,
						'field_name'=>$failed_field_name
					)
				);
				return(0);
			}	
		}

		/**
		* \todo better system: do not display
		* */

		function ac_create(){
			global $i18n,$i18n_std;
			$data=array();
			foreach($this->fields as $k=>$field){
				if($k==$this->id){
					/* better system: do not display*/
					$data[0][$k]='0';	/*Mysql for NEW WARNING: Mysql Dependant*/
				}else{
					$data[0][$k]=$field['default'];
				}
			}
			$this->fields[$this->id]['type']='hidden';/*Hide the ID */
			$this->ed(array(
				'actions'=>array('new2'),
				'title'=>'new_table_title',
				'data'=>$data,
				'fields'=>$this->fields,
			));

		}

		/**a wrapper for std::grid() */
		function sgrid($fields,$data,$options=array()){
			$this->shadow($this->grid($fields,$data,$options),'shadow','center','50%');
		}
		
		/**
			this generates a small grid so you can edit multiple values at once.
			parameters:
				fields: a list of fields
				data:	a bi-dimensional array with the data
				options:a keyed array with the following options:

					head:	headers for the grid
					table_style
					table_border	
				note: the options array is passed directly to form()
						
		 [] is not automagicaly added to fields, since you might not want it
		 \todo autodetect?
		
		 restrictions: options[] HAS to contain a "strings" key, with the form's strings 
		 (remember, this is simply )
		\todo add nobr
		 * */
		
	function grid($fields,$data,$options=array()){

		$n=new form($fields,$options);
		#$n->strings=$options["strings"];
		$out=array();
		$head=$options["head"];
		$out2="";
		$b='';
		foreach($data as $k=>$row){
			
			foreach($row as $k1=>$field_data){
				$n->fields[$k1]["value"]=$field_data;
			}
			$b=$n->bare_fields();
			
			$out[$k]=$b["visible_fields"];
			$out2.=$b["hidden_fields"];
		}
		return(	$b["head"].
			$this->table($out,$head,array(
				'footer'=>$b["buttons"],
				'title'=>$b["title"],
				'style'=>$options["table_style"],
				'border'=>$options["table_border"],
			)).
			$b["foot"]
		);
	}	
		/**
		 parameters (pretty much everything you would see on the View()
		 )
		 options.filter
		 options.restrict
		 options.fields

		 at the end of the table, multiple actions are permitted, over many items (selected trough checkbox on the left)
		 this allows us to do stuff like "delete multiple items" button

		 if results are more than $config.pagination_limit, the results are paginated, so that 
		 no more than $config.pagination_limit are shown per page.
		*controls that allow you to go to the Next page, and the PRevious page, are also set.

		 if a collumn belongs to another table (i.e  is foreign) it is identified so, and information from
		 the other tables is brought (using SQL Join), using the SQl relationships information.

		 this function replicates functionality from base_class.my_list(), with many improvements.
		
		\todo
		\todo search
		\todo send to template
		\todo allow customization, @ app level OK , mod level OK , & view level NO (kindof, using view.type: view handlers)
		\todo checkbox for selecting multiple items
		\todo security? wtf is this about?
		\todo multiple filters, separated by ,
		\todo on foreign collumn: click to view item.

		 * */
		function ml($options){

			global $i18n,$i18n_std,$mydir;

			if(!array_key_exists('check',$options)){$options['check']=1;}/** Options.check is enabled by default, but can be explicitely disabled.*/
			#default filter: void.
			$filter=$options["filter"];
			if($filter==''){$filter='none';}
			#default filter: void.
			$restrict=$options["restrict"];
			if($restrict==''){$restrict='1=1';}

			$view_fields=$options["fields"];
			$title=$i18n[$this->name][$options["title"]];

			$ss=array('up'=>'ASC','down'=>'DESC');

			/*Which Sort Direction: GET, default VIEW, or simply ID, in that order.*/
			if(""==($sort_direction=$ss[$this->remove_strange_chars($_GET['sort_direction'])])){
				if(!array_key_exists('sort_direction',$options)){
					$sort_direction=$ss['up'];
				}else{
					$sort_direction=$options['sort_direction'];
				}
			}
			
			/*Which Sort field: GET, default VIEW, or simply ID, in that order.*/
			if(""==($sort_field=$this->remove_strange_chars($_GET['sort']))){
				if(!array_key_exists('sort_field',$options)){
					if($sort_field==''){
						$sort_field=$this->table.'.'.$this->id;
					}
				}else{
					$sort_field=$options['sort_field'];
				}
			}

			$page=$this->remove_strange_chars($_GET['page']);
			if($page==""){$page=0;}

			if($options["template"]==""){
				$in_template=0;
			}else{
				$in_template=1;
				$tmpl=file_get_contents("./templates/".$options["template"].".html");
			}

			#returns an array.

			$q=$this->foreign_select(array(
				'fields'=>$view_fields,
				'sort_field'=>$sort_field,
				'sort_direction'=>$sort_direction,
				'restrict'=>$restrict,
			));
			#gets the pagination query
			$qmax=$this->q2obj($q['csql']);
			$max=$qmax[0]["c"];
			#retrieve the pagination scheme.
			$pghtml=$this->pagination_scheme(
				array(
					'page'=>$page,
					'max'=>$max,
					'link'=>array(
						'mod'=>$this->name,
						'ac'=>$_GET["ac"],
						'sort'=>$sort_field,
						'sort_direction'=>$sort_direction,
					)
				)	
			);
			
			$sfields=$q['sfields'];
			if(count($sfields)==0){
				$this->i_error('no_fields_error','std120');
				return(0);
			}
			
			///p2($q,'violet');
			
			$sql=$q['sql'].$this->db_paginate_sql($page);

			/**
			 * \todo if @ last page, and there are previous pages, and there are no records, then go back one page
			 * \todo if not aliased check, sTHIS ERROR IS DEPRECATED UNTIL WE FIND A WAY OF DETERMINING IF THE FIELD AINT THERE; NOT EVEN W/ ALIAS.
			 */	
#			if(!in_array($sort_field,$sfields)){
#				$this->error('no field '.$sort_field." in list: ".implode(',',$sfields),'std005');//FIX i18n
#			}

			$got_headers=$this->get_headers();
			$headers=array();

			#header info, and sort stuff
			/**\todo sadly, i must replicate functionality described @ foreign_select, fix that (somehow...)*/
			$ialias=0;
			/**\todo MUST SOMEHOW GET THE HEADERS DATA FROM FOREGN_SELECT*/
			#
			$na=$this->need_alias($which_fields);#FIXME
			
			$my_op=array();
			$current_fields=array($this->id=>$this->table.'_'.$this->id);//THESE FIELDS ARE THE ONES BEING SHOWN AT THE MOMENT (by default, ID is always visible.)
						//TODO: add this to VIEW, so you can have "hidden" fields!.
						//

			foreach($view_fields as $k=>$field){
				//people shouldn't be able to remove the ID, since it contains the checkbox Functionality!.
				if($field['name']!=$this->id){
					$my_op[$k]=$this->fi($k);
				}
				if(in_array($k,$_GET["fields"])){
					$current_fields[$k]=$q["sql_fields"][$k];	//id=>table_id
				}
			}
			
			//HEADERS SECTION
			foreach($view_fields as $k=>$field){
				if(!array_key_exists($k,$current_fields)){
					continue;
				}
				$fname=$sfields[$k];
				
				$is_foreign=array_key_exists('foreign',$field);
				
				if($this->field_is_foreign($field)){	
											#field is foreign, join tables,
											#why do i do this here too? 
					if($is_foreign){
						$e=explode('.',$field["foreign"]);
						$tname=$e[0];

						$f1name=$e[1];								
					}else{
						$fm=$this->load_file($this->id2mod($k));
						$tname=$fm->table;
						$f1name=$fm->name;
					}
					
					if($na==1){
						echo("NA:$na");
						$tblalias=$tname.'_alias_'.$ialias;
					}else{
						$tblalias=$tname;
					}
					$fname=$tblalias.'_'.$f1name;			
					
					#OLD:
					#$fname=$q['table_aliases'][$fm->table].".".$fm->name;

					
					$ialias++;
				}else{
					$fname=$this->table.".".$k;
				}
				$this->log('FIELD:'.$fname.'IM USING ALIAS:'.$na,'8');
				if($sort_field == $fname  && $sort_direction == $ss['up']){
					$dir='down';
				}else{
					$dir='up';
				}
				/**
				#AH? wtf is this? what do i mean? 
				\todo allow customization of list in link, so you can have different views right there.
				\todo add help here:link.
					
				 */
				$headers[]='<a class="list_link" title="'.$this->fh($field['name']).'" href="?mod='.$this->table.'&ac=view:'.$this->current_view.'&sort='.$fname.'&sort_direction='.$dir.'&page='.$page.'">'.$got_headers[$k]."</a>";
			}

			$l=$this->q2obj($sql);

			$headers[]=$i18n_std['list']['actions'];

			$c=0;
			$func="filter_$filter";
			for($i=0;$i<count($l);$i++){
				$l[$i]=$this->$func($i,$l[$i]);
			}
			#P2($current_fields,'green');
			foreach($l as $k=>$row){
				
				$final[$c]=array();
				$myid=$row[$this->table."_".$this->id];
				
				//if(!array_key_exists($myid,$row)){	/*what am i protected here from?*/
				//	$this->error('severe:'.$myid." is not in array ".implode(",",$row));
				//	p2($row);
				//	break;
				//}
				/**	
				#fix whatever you might need to.
				\todo be able to skip rows based on filter.
				 */

				foreach($row as $k1=>$field){
					if(!in_array($k1,$current_fields)){
						
						continue;
					}
					$final[$c][$k1]=$field;
				}
				#WARNING
				if($options['check']){
					$final[$c][$this->table.'_'.$this->id]='<input type=checkbox name="item[]" value="'.$myid.'" title="'.$myid.'" style="" class="">';//SHOULD WE SHOW THE ID?
				}

				$dxx='';
				foreach($options["side_actions"] as $k9=>$v9){
					$dxx.='<a href="?ac='.$v9.'&id='.$myid.'&mod='.$this->name.'" title="'.$i18n_std['list']['help_side_'.$v9].'">'.$i18n_std['list']['side_'.$v9].'</a>&nbsp;';
				}
				'<a href="?ac=delete&id='.$myid.'&mod='.$this->name.'">'.$i18n_std['list']['delete'].'</a>';
				
				$final[$c]['__actions']=$dxx;
				$c++;
			}
			
			$final_actions="<div align=left class=page_container>$pghtml</div>";
			$t6=new form();//contains all the buttons
			$t6->strings=array();
			/* 
			 * Select Collumns section
			 * */
			//WARNING: adding a field, is too much work, there's got to be an easier way !
			/*
			$t6->add_field(array('name'=>'fields1','type'=>'checklist','options'=>$my_op));
			$t6->strings[0]=$this->get_i18n_text('fields');
			$t6->strings["help_0"]=$this->get_i18n_text('help_fields');
			*/

			$t6->add_field(array('name'=>'mod','type'=>'hidden','value'=>$this->table));
			/** \todo ADD hidden inputs for state, like sort field, sort ac, and search term. to t6
			 * \todo allow user settings to override $i18n_std['list']
			 * */

			if(is_array($options["down_actions"]) || count($options["down_actions"])!=0){
				foreach($options["down_actions"] as $k=>$v){
					$t6->add_submit_button(array('label'=>$i18n_std['list']['down_'.$v],'action'=>$v));//$this->table.'/'.
				}
			}
			//This adds more options to the main form, from the sub-form.
			///\todo ALLOW THIS PROCCESS TO BE SIMPLER!.
			$o2=$this->get_presets_form($my_op,'default');
			foreach($o2["o"] as $k55=>$v55){
				$t6->add_submit_option($v55);
			}
			///

			$form_struct=$t6->bare_fields();
			#p2($form_struct);
			/*
			if(is_array($options["down_actions"]) || count($options["down_actions"])!=0){
				foreach($options["down_actions"] as $k=>$v){
					#WARNING: this call syntax is repeated in view, be 
					#careful not to change this, in one place only
					$final_actions.='<a href="?mod='.$this->table.'&ac='.$v.'" title="'.$i18n_std['list']['help_down_'.$v] .'">'.$i18n_std['list']['down_'.$v].'</a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
				}
			}	
			$final_actions.='<br/>';
			 */

			$ending='<table width=100%><tr><td class=list_footer>'.
						"<div align=left class='page_container list_footer'>$pghtml</div>".
						"</td><td valign=bottom>".
						$form_struct["buttons"]."</td></tr></table>";

			$success=1;
			$envelope=1;
			$level9=$form_struct["head"];

			if(count($final)==0){
				$t=$this->get_i_msg('no_items',array('name'=>$i18n[$this->table]['table_plural'],'ac'=>$ending));	
				$success=0;
				$envelope=0;
			}elseif($in_template==0){
				/** \todo allow CHECKBOX in templates (for now it's only in table())*/
				#old fashoned table()

				$t=$this->table($final,$headers,
					array(
						'title'=>$title.$o2["c"],//TODO FIXME FIX 
						'footer'=>$ending,
						'style'=>'list',			/** \todo own style, LIST*/
						'border'=>'0',
					));
			}else{
				#This section will draw the information, using a template.
				#hopefully, this is not too complex, if so don't worry, its not that hard (i think)
				#

				$i18n[$this->table]["pagination_control"]=$pghtml;
				foreach($final as $kt1=>$vt1){
					
					foreach($i18n[$this->table] as $kt=>$vt){
						#if(array_key_exists($kt,$final[$kt1])){
							#woa
						
						#}else{	
							$final[$kt1]["i18n_".$kt]=$vt;//i18n prefix is added so we dont ave any compatibility problems.
						#}	
					}		
				}		
				
				$tree=array('isnode'=>1);
				$tree['HEADER']=array();
				$tree['FOOTER']=array();
				$tree['CONTENT']['LOOP']=array(
					'HEADER'=>$i18n[$this->table],	#Everything that you put on i18n, will be visible from here, how that...
					'FOOTER'=>$i18n[$this->table],	
					'CONTENT'=>$final,	#q2obj's output
					'isnode'=>1,
				);
				
				###echo("<h1>template</h1>");p2($tmpl);echo("<h1>result</h1>");p2($tree);
				#p2($tree);		
				$tmpl=$this->parse_add_files($tmpl,'INCLUDE_');
				echo($this->parse_template($tree,$tmpl,'CONTENT','_'));
				$this->log("Available keys to the Template:".implode(" , ",array_keys($final[0])));
				#echo("woa...");
			}
			if($in_template==0){
				#level9 means almost out
			
				$level9.=$t;
				$level9.=implode("\n",$form_struct["hidden_fields"]);
				$level9.=$form_struct["foot"];
				if($envelope==1){
					$this->shadow($level9,'shadow','center','60%');	
				}else{
					echo($level9);
				}	
			}	
			return($success);		

		}#end ml
		
		/**
		 * this function prints 4 buttons: first, next, last, previous, when they make sense.
	 		Parameters: 
			options.max	: maximun number of pages
			options.page	: current Page
			options.link	: link array options, that allow us to set: mod, ac, etc, in a make_link fashon.

			\todo multiple pagination schemes.
			\todo make this a range: 1 ... x-5 , x-4 ... x , x+1,x+2, ... x+5, last
			\todo what if im beyond, or below the limit?
		 * */
		function pagination_scheme($options){

			global $config,$i18n_std,$i18n;
			$max=$options["max"];
			$page=$options["page"];
			$page_limit=$config["pagination_limit"];

			$link_options=$options["link"];
			#	p2($link_options);
			#what are the remainding pages (final pat that does not amount to page_limit.)
			
			$remainder= $max % $page_limit;
			
			#substract remainder from max so its perfectly divisible by page_limit, 
			#and gives us the maximum number of pages available

			$max_pages= ($max - $remainder) / $page_limit ;
			
			if($remainder==0){
				#We are in the LAST page, go back
				$max_pages--;
			}
			
			$txt="";	#output buffer

			#section 1, simple navigation
			
			if($max_pages!=0){
				if($page!=0){
					#first page link appears only when im not on it.
					$a=$link_options;
					$a["page"]=0;
					$txt.=$this->make_link($a,$i18n_std["pagination"]["first"],"page_link")."&nbsp;&nbsp;";
					if($page!=1){
						$a["page"]=$page-1;
						$txt.=$this->make_link($a,$i18n_std["pagination"]["previous"],"page_link")."&nbsp;&nbsp;";
					}	
				}
				if($page!=$max_pages){
					#LAST, and NEXT page links appear only when i'm not on the last page.
					$a=$link_options;
					if($page!=($max_pages-1)){
						$a["page"]=1+$page;
						$txt.=$this->make_link($a,$i18n_std["pagination"]["next"],"page_link")."&nbsp;&nbsp;";
					}			
					$a["page"]=$max_pages;
					$txt.=$this->make_link($a,$i18n_std["pagination"]["last"],"page_link")."&nbsp;&nbsp;";		
				}
				#s3ction 2, each page of the results, for the "pagination lawyers"

				$txt.="<br/>";
				$txt.=$i18n_std["pagination"]["go"].":";	

				foreach(range(0, $max_pages) as $k=>$v){
					if($page==$v){
						#actual link, is useless.
						$txt.="&nbsp;<a class=current_page_link href=#>".(1+$v)."</a>";
					}else{
						$txt.="&nbsp;&nbsp;";
						
						$a=$link_options;
						$a["page"]=$v;
						$txt.=$this->make_link($a,1+$k,"page_link")."&nbsp;";
						
				
					}	
				}
			}else{
				#there's only one page, no need for all this stuff.
			}
			#setcion 3, display information
			#
			$txt.="<br/>";
			
			if($max_pages!=0){
				#gives something like: Page X of Y 
				$txt.=	$i18n_std["pagination"]["page"].":".
					"<b>".(1+$page)."</b>".$i18n_std["pagination"]["of"].
					"<b>".(1+$max_pages)."</b>"."&nbsp;&nbsp;|&nbsp;&nbsp;";

			}
			$txt.=	$i18n_std["pagination"]["total"]." ".$i18n[$this->name]["table_plural"].":".
				"<b>$max</b> &nbsp;";
			
			return($txt);
		}

		/**
		 * @param $mod the name of the module (no extension, no path, just "usr", or "edit", etc)
		 * @returns the module object
			this loads a file, and all of its necesary stuff, like language stuff, etc
			it also prints a nice error mesage when the module is not found
			this is a lot like base_class::load_module()
			ahh, the good days...
			
			\todo check if class was created
			\todo 9876  add prefix
		 */
		function load_file($mod){
			
			global $i18n,$i18n_std,$std_fields;
			#echo("loading:$mod");
			$mod=strtolower($mod);//	WARNING: if your module, hs uppercase stuff, sorry man.
			$f="./controller/".$mod.".controller.php";
			$is_shared=0;
			$model_file="./model/".$mod.".model.php";
			if(!file_exists($f)){
				//echo("<br/>no file seek shared");
				$f="../shared/controller/".$mod.".controller.php";
				$is_shared=1;
				$model_file="../shared/model/$mod.model.php";
				
				if(!file_exists($f)){
					//echo("no such file");
					$this->i_error('no_such_module','std040',array('mod'=>$mod));
					return(0);
				}
			}

			$lang_file='./i18n/'.LANGUAGE.'/'.$mod.'.i18n.php';
			if(!file_exists($lang_file)){
				//echo("<br/>load shared lang file");
				$lang_file='../shared/i18n/'.LANGUAGE.'/'.$mod.".i18n.php";
				if(!file_exists($lang_file)){					
					$this->i_error('no_strings_file','std041');
				}
			}

			#load views
			#9876
			$views_file='./view/'.$mod.'.view.php';
			if(!file_exists($views_file)){
				//echo("<br/>load shared lang file");
				$views_file='../shared/view/'.$mod.".view.php";
				if(!file_exists($views_file)){					
					#NO longer a problem, since we have SHARED VIEWS,
					#altough, IF your view isn't on the shared ones, check std075
					#$this->i_error('no_views_file','std042');
				}else{
					require_once($views_file);
				}
			}else{
				require_once($views_file);
			}

			#echo("views:$views_file");
			require_once($lang_file);
			#echo($is_shared);
			if(file_exists($model_file)){
				#if the file does not exists, it no problem, its a procedural module, not a CRUD module,
				#altough, this WILL make you shoot yourself in the Foot..
				require_once($model_file);
				
			}else{
				$this->log("model file was not found:$model_file",0);
			}
			require_once($f);
			$mod1=null;
			eval("\$mod1 = new ${mod}_model();");
			$mod1->fields=$std_fields[$mod];
			return($mod1);
			
		}
	}#end std
?>
